<!doctype html>
<html>
<head>
    <title>Tor 0.3.0.1-alpha: A new alpha series begins | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="Tor 0.3.0.1-alpha: A new alpha series begins | Tor Project">
    <meta property="og:description" content="Now that Tor 0.2.9.8 is stable, it&#39;s time to release a new alpha series for testing and...">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/tor-0301-alpha-new-alpha-series-begins/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        Tor 0.3.0.1-alpha: A new alpha series begins
      </h1>
    <p class="meta">by nickm | December 19, 2016</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>Now that <a href="https://blog.torproject.org/blog/tor-0298-released-finally-new-stable-series" rel="nofollow">Tor 0.2.9.8 is stable</a>, it's time to release a new alpha series for testing and bug-hunting!<br />
Tor 0.3.0.1-alpha is the first alpha release in the 0.3.0 development series. It strengthens Tor's link and circuit handshakes by identifying relays by their Ed25519 keys, improves the algorithm that clients use to choose and maintain their list of guards, and includes additional backend support for the next-generation hidden service design. It also contains numerous other small features and improvements to security, correctness, and performance.<br />
You can download the source from the usual place on the website. Packages should be available over the next weeks, including an alpha TorBrowser release some time in January.<br />
Please note: This is an alpha release. Please expect more bugs than usual. If you want a stable experience, please stick to the stable releases.</p>

<p>Below are the changes since 0.2.9.8.</p>

<h2>Changes in version 0.3.0.1-alpha - 2016-12-19</h2>

<ul>
<li>Major features (guard selection algorithm):
<ul>
<li>Tor's guard selection algorithm has been redesigned from the ground up, to better support unreliable networks and restrictive sets of entry nodes, and to better resist guard-capture attacks by hostile local networks. Implements proposal 271; closes ticket <a href="https://bugs.torproject.org/19877" rel="nofollow">19877</a>.
  </li>
</ul>
</li>
<li>Major features (next-generation hidden services):
<ul>
<li>Relays can now handle v3 ESTABLISH_INTRO cells as specified by prop224 aka "Next Generation Hidden Services". Service and clients don't use this functionality yet. Closes ticket <a href="https://bugs.torproject.org/19043" rel="nofollow">19043</a>. Based on initial code by Alec Heifetz.
  </li>
<li>Relays now support the HSDir version 3 protocol, so that they can can store and serve v3 descriptors. This is part of the next- generation onion service work detailled in proposal 224. Closes ticket <a href="https://bugs.torproject.org/17238" rel="nofollow">17238</a>.
  </li>
</ul>
</li>
<li>Major features (protocol, ed25519 identity keys):
<ul>
<li>Relays now use Ed25519 to prove their Ed25519 identities and to one another, and to clients. This algorithm is faster and more secure than the RSA-based handshake we've been doing until now. Implements the second big part of proposal 220; Closes ticket <a href="https://bugs.torproject.org/15055" rel="nofollow">15055</a>.
  </li>
<li>Clients now support including Ed25519 identity keys in the EXTEND2 cells they generate. By default, this is controlled by a consensus parameter, currently disabled. You can turn this feature on for testing by setting ExtendByEd25519ID in your configuration. This might make your traffic appear different than the traffic generated by other users, however. Implements part of ticket <a href="https://bugs.torproject.org/15056" rel="nofollow">15056</a>; part of proposal 220.
  </li>
<li>Relays now understand requests to extend to other relays by their Ed25519 identity keys. When an Ed25519 identity key is included in an EXTEND2 cell, the relay will only extend the circuit if the other relay can prove ownership of that identity. Implements part of ticket <a href="https://bugs.torproject.org/15056" rel="nofollow">15056</a>; part of proposal 220.
  </li>
</ul>
</li>
</ul>

<p> </p>

<ul>
<li>Major bugfixes (scheduler):
<ul>
<li>Actually compare circuit policies in ewma_cmp_cmux(). This bug caused the channel scheduler to behave more or less randomly, rather than preferring channels with higher-priority circuits. Fixes bug <a href="https://bugs.torproject.org/20459" rel="nofollow">20459</a>; bugfix on 0.2.6.2-alpha.
  </li>
</ul>
</li>
<li>Minor features (controller):
<ul>
<li>When HSFETCH arguments cannot be parsed, say "Invalid argument" rather than "unrecognized." Closes ticket <a href="https://bugs.torproject.org/20389" rel="nofollow">20389</a>; patch from Ivan Markin.
  </li>
</ul>
</li>
<li>Minor features (diagnostic, directory client):
<ul>
<li>Warn when we find an unexpected inconsistency in directory download status objects. Prevents some negative consequences of bug <a href="https://bugs.torproject.org/20593" rel="nofollow">20593</a>.
  </li>
</ul>
</li>
<li>Minor features (directory authority):
<ul>
<li>Add a new authority-only AuthDirTestEd25519LinkKeys option (on by default) to control whether authorities should try to probe relays by their Ed25519 link keys. This option will go away in a few releases--unless we encounter major trouble in our ed25519 link protocol rollout, in which case it will serve as a safety option.
  </li>
</ul>
</li>
<li>Minor features (directory cache):
<ul>
<li>Relays and bridges will now refuse to serve the consensus they have if they know it is too old for a client to use. Closes ticket <a href="https://bugs.torproject.org/20511" rel="nofollow">20511</a>.
  </li>
</ul>
</li>
<li>Minor features (ed25519 link handshake):
<ul>
<li>Advertise support for the ed25519 link handshake using the subprotocol-versions mechanism, so that clients can tell which relays can identity themselves by Ed25519 ID. Closes ticket <a href="https://bugs.torproject.org/20552" rel="nofollow">20552</a>.
  </li>
</ul>
</li>
<li>Minor features (fingerprinting resistence, authentication):
<ul>
<li>Extend the length of RSA keys used for TLS link authentication to 2048 bits. (These weren't used for forward secrecy; for forward secrecy, we used P256.) Closes ticket <a href="https://bugs.torproject.org/13752" rel="nofollow">13752</a>.
  </li>
</ul>
</li>
<li>Minor features (infrastructure):
<ul>
<li>Implement smartlist_add_strdup() function. Replaces the use of smartlist_add(sl, tor_strdup(str)). Closes ticket <a href="https://bugs.torproject.org/20048" rel="nofollow">20048</a>.
  </li>
</ul>
</li>
<li>Minor bugfixes (client):
<ul>
<li>When clients that use bridges start up with a cached consensus on disk, they were ignoring it and downloading a new one. Now they use the cached one. Fixes bug <a href="https://bugs.torproject.org/20269" rel="nofollow">20269</a>; bugfix on 0.2.3.12-alpha.
  </li>
</ul>
</li>
<li>Minor bugfixes (configuration):
<ul>
<li>Accept non-space whitespace characters after the severity level in the `Log` option. Fixes bug <a href="https://bugs.torproject.org/19965" rel="nofollow">19965</a>; bugfix on 0.2.1.1-alpha.
  </li>
<li>Support "TByte" and "TBytes" units in options given in bytes. "TB", "terabyte(s)", "TBit(s)" and "terabit(s)" were already supported. Fixes bug <a href="https://bugs.torproject.org/20622" rel="nofollow">20622</a>; bugfix on 0.2.0.14-alpha.
  </li>
</ul>
</li>
<li>Minor bugfixes (consensus weight):
<ul>
<li>Add new consensus method that initializes bw weights to 1 instead of 0. This prevents a zero weight from making it all the way to the end (happens in small testing networks) and causing an error. Fixes bug <a href="https://bugs.torproject.org/14881" rel="nofollow">14881</a>; bugfix on 0.2.2.17-alpha.
  </li>
</ul>
</li>
<li>Minor bugfixes (descriptors):
<ul>
<li>Correctly recognise downloaded full descriptors as valid, even when using microdescriptors as circuits. This affects clients with FetchUselessDescriptors set, and may affect directory authorities. Fixes bug <a href="https://bugs.torproject.org/20839" rel="nofollow">20839</a>; bugfix on 0.2.3.2-alpha.
  </li>
</ul>
</li>
<li>Minor bugfixes (directory system):
<ul>
<li>Download all consensus flavors, descriptors, and authority certificates when FetchUselessDescriptors is set, regardless of whether tor is a directory cache or not. Fixes bug <a href="https://bugs.torproject.org/20667" rel="nofollow">20667</a>; bugfix on all recent tor versions.
  </li>
<li>Bridges and relays now use microdescriptors (like clients do) rather than old-style router descriptors. Now bridges will blend in with clients in terms of the circuits they build. Fixes bug <a href="https://bugs.torproject.org/6769" rel="nofollow">6769</a>; bugfix on 0.2.3.2-alpha.
  </li>
</ul>
</li>
<li>Minor bugfixes (ed25519 certificates):
<ul>
<li>Correctly interpret ed25519 certificates that would expire some time after 19 Jan 2038. Fixes bug <a href="https://bugs.torproject.org/20027" rel="nofollow">20027</a>; bugfix on 0.2.7.2-alpha.
  </li>
</ul>
</li>
<li>Minor bugfixes (hidden services):
<ul>
<li>Stop ignoring misconfigured hidden services. Instead, refuse to start tor until the misconfigurations have been corrected. Fixes bug <a href="https://bugs.torproject.org/20559" rel="nofollow">20559</a>; bugfix on multiple commits in 0.2.7.1-alpha and earlier.
  </li>
</ul>
</li>
<li>Minor bugfixes (memory leak at exit):
<ul>
<li>Fix a small harmless memory leak at exit of the previously unused RSA-&gt;Ed identity cross-certificate. Fixes bug <a href="https://bugs.torproject.org/17779" rel="nofollow">17779</a>; bugfix on 0.2.7.2-alpha.
  </li>
</ul>
</li>
<li>Minor bugfixes (util):
<ul>
<li>When finishing writing a file to disk, if we were about to replace the file with the temporary file created before and we fail to replace it, remove the temporary file so it doesn't stay on disk. Fixes bug <a href="https://bugs.torproject.org/20646" rel="nofollow">20646</a>; bugfix on tor-0.2.0.7-alpha. Patch by fk.
  </li>
</ul>
</li>
<li>Minor bugfixes (Windows):
<ul>
<li>Check for getpagesize before using it to mmap files. This fixes compilation in some MinGW environments. Fixes bug <a href="https://bugs.torproject.org/20530" rel="nofollow">20530</a>; bugfix on 0.1.2.1-alpha. Reported by "ice".
  </li>
</ul>
</li>
<li>Code simplification and refactoring:
<ul>
<li>Abolish all global guard context in entrynodes.c; replace with new guard_selection_t structure as preparation for proposal 271. Closes ticket <a href="https://bugs.torproject.org/19858" rel="nofollow">19858</a>.
  </li>
<li>Introduce rend_service_is_ephemeral() that tells if given onion service is ephemeral. Replace unclear NULL-checkings for service directory with this function. Closes ticket <a href="https://bugs.torproject.org/20526" rel="nofollow">20526</a>.
  </li>
<li>Extract magic numbers in circuituse.c into defined variables.
  </li>
<li>Refactor circuit_is_available_for_use to remove unnecessary check.
  </li>
<li>Refactor circuit_predict_and_launch_new for readability and testability. Closes ticket <a href="https://bugs.torproject.org/18873" rel="nofollow">18873</a>.
  </li>
<li>Refactor large if statement in purpose_needs_anonymity to use switch statement instead. Closes part of ticket <a href="https://bugs.torproject.org/20077" rel="nofollow">20077</a>.
  </li>
<li>Refactor the hashing API to return negative values for errors, as is done as throughout the codebase. Closes ticket <a href="https://bugs.torproject.org/20717" rel="nofollow">20717</a>.
  </li>
<li>Remove data structures that were used to index or_connection objects by their RSA identity digests. These structures are fully redundant with the similar structures used in the channel abstraction.
  </li>
<li>Remove duplicate code in the channel_write_*cell() functions. Closes ticket <a href="https://bugs.torproject.org/13827" rel="nofollow">13827</a>; patch from Pingl.
  </li>
<li>Remove redundant behavior of is_sensitive_dir_purpose, refactor to use only purpose_needs_anonymity. Closes part of ticket <a href="https://bugs.torproject.org/20077" rel="nofollow">20077</a>.
  </li>
<li>The code to generate and parse EXTEND and EXTEND2 cells has been replaced with code automatically generated by the "trunnel" utility.
  </li>
</ul>
</li>
<li>Documentation:
<ul>
<li>Include the "TBits" unit in Tor's man page. Fixes part of bug <a href="https://bugs.torproject.org/20622" rel="nofollow">20622</a>; bugfix on tor-0.2.5.1-alpha.
  </li>
<li>Change '1' to 'weight_scale' in consensus bw weights calculation comments, as that is reality. Closes ticket <a href="https://bugs.torproject.org/20273" rel="nofollow">20273</a>. Patch from pastly.
  </li>
<li>Correct the value for AuthDirGuardBWGuarantee in the manpage, from 250 KBytes to 2 MBytes. Fixes bug <a href="https://bugs.torproject.org/20435" rel="nofollow">20435</a>; bugfix on tor-0.2.5.6-alpha.
  </li>
<li>Stop the man page from incorrectly stating that HiddenServiceDir must already exist. Fixes 20486.
  </li>
<li>Clarify that when ClientRejectInternalAddresses is enabled (which is the default), multicast DNS hostnames for machines on the local network (of the form *.local) are also rejected. Closes ticket <a href="https://bugs.torproject.org/17070" rel="nofollow">17070</a>.
  </li>
</ul>
</li>
<li>Removed features:
<ul>
<li>The AuthDirMaxServersPerAuthAddr option no longer exists: The same limit for relays running on a single IP applies to authority IP addresses as well as to non-authority IP addresses. Closes ticket <a href="https://bugs.torproject.org/20960" rel="nofollow">20960</a>.
  </li>
<li>The UseDirectoryGuards torrc option no longer exists: all users that use entry guards will also use directory guards. Related to proposal 271; implements part of ticket <a href="https://bugs.torproject.org/20831" rel="nofollow">20831</a>.
  </li>
</ul>
</li>
<li>Testing:
<ul>
<li>New unit tests for tor_htonll(). Closes ticket <a href="https://bugs.torproject.org/19563" rel="nofollow">19563</a>. Patch from "overcaffeinated".
  </li>
<li>Perform the coding style checks when running the tests and fail when coding style violations are found. Closes ticket <a href="https://bugs.torproject.org/5500" rel="nofollow">5500</a>.
  </li>
<li>Add tests for networkstatus_compute_bw_weights_v10.
  </li>
<li>Add unit tests circuit_predict_and_launch_new.
  </li>
<li>Extract dummy_origin_circuit_new so it can be used by other test functions.
  </li>
</ul>
</li>
</ul>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/network">
          network
        </a>
      </li><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-226801"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-226801" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">December 20, 2016</p>
    </div>
    <a href="#comment-226801">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-226801" class="permalink" rel="bookmark">Tor will not load for me at</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Tor will not load for me at all since the update. Nothing will load. Is anyone else having this issue?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-227274"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-227274" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  arma
  </article>
    <div class="comment-header">
      <p class="comment__submitted">arma said:</p>
      <p class="date-time">December 22, 2016</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-226801" class="permalink" rel="bookmark">Tor will not load for me at</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-227274">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-227274" class="permalink" rel="bookmark">Since what update? I think</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Since what update? I think you might be posting this comment to the wrong blog post.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-226903"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-226903" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">December 21, 2016</p>
    </div>
    <a href="#comment-226903">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-226903" class="permalink" rel="bookmark">Just built Tor 0.3.0.1-alpha</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Just built Tor 0.3.0.1-alpha or 'thought I did', as the download from the torproject.org tor source site provided the file with that name. I built it and then noticed when I asked what version it is as I suspected something was not right, it told me $ tor --version<br />
Tor version 0.2.8.6</p>
<p>Imagine my surprise and disappointment. Why would these builds get mixed up like that and the filename on the archives indicate Tor 0.3.0.1-alpha on them? Wow, bad hair day I guess. Please fix this foobar ASAP.</p>
<p>Archive Package Name: tor-0.3.0.1-alpha.tar.gz<br />
Size 5.7 MB (5704559 bytes)<br />
$ sha1sum tor-0.3.0.1-alpha.tar.gz<br />
67bf36d91caf60c9227910474d6e8402b8b6ad04  tor-0.3.0.1-alpha.tar.gz</p>
<p>Displays Tor version 0.2.8.6</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-226927"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-226927" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  arma
  </article>
    <div class="comment-header">
      <p class="comment__submitted">arma said:</p>
      <p class="date-time">December 21, 2016</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-226903" class="permalink" rel="bookmark">Just built Tor 0.3.0.1-alpha</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-226927">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-226927" class="permalink" rel="bookmark">I assume you have a problem</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I assume you have a problem with your $PATH. Specifically, I bet a Tor 0.2.8.6 is in your $PATH, and this new Tor that you built is not.</p>
<p>From your build directory, try running "src/or/tor --version"</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-227252"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-227252" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">December 21, 2016</p>
    </div>
              <p class="parent visually-hidden">In reply to arma</p>
    <a href="#comment-227252">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-227252" class="permalink" rel="bookmark">Thanks arma, it was way</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Thanks arma, it was way early in the AM and I had been accidently inquiring the tor binary version I had installed in my system files and not that of the local tor binary I just built in my user folder area. $ tor --version  and I should have been using $ ./tor --version</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-227266"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-227266" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  arma
  </article>
    <div class="comment-header">
      <p class="comment__submitted">arma said:</p>
      <p class="date-time">December 21, 2016</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-227252" class="permalink" rel="bookmark">Thanks arma, it was way</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-227266">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-227266" class="permalink" rel="bookmark">Good to hear it&#039;s working</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Good to hear it's working for you now!</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div></div><a id="comment-227260"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-227260" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">December 21, 2016</p>
    </div>
    <a href="#comment-227260">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-227260" class="permalink" rel="bookmark">It looks like those Curves</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>It looks like those Curves are infecting the whole tor infrastructure, at a time when AES, still the best available when fitted with a proper key size - as math works! - is HW accelerated in all available processors ever since 3-4 years ago.<br />
<a href="https://en.wikipedia.org/wiki/AES_instruction_set" rel="nofollow">https://en.wikipedia.org/wiki/AES_instruction_set</a></p>
<p>I've suggested once that the Curves encryption is simplistic/lame and that the encrypted streams, superficially analyzed, are easily identifiable as tor, as the Curves don't seem to have gained that much territory in the https implementation.<br />
Nevertheless, according to the tor metrics half of the tot relays are still running tor 0.2.5.x - where ntor and the Curves were not yet democratically enforced.</p>
<p>I must admit, as interested as I am in the Curves development, there's nothing I have seen/red in the last period that made me change my mind about their weak security. All the explanations are really subjective and without any underlying  mathematical proof / study, including Mr. Bernstein's speeches, that are rather superficial and boring, sometimes at a kindergarten level.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-227273"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-227273" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  arma
  </article>
    <div class="comment-header">
      <p class="comment__submitted">arma said:</p>
      <p class="date-time">December 22, 2016</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-227260" class="permalink" rel="bookmark">It looks like those Curves</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-227273">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-227273" class="permalink" rel="bookmark">I think you might be</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I think you might be confused about how ECC compares to AES -- elliptic curve crypto is asymmetric, like RSA, whereas AES is symmetric, like DES. So wondering about the use of curves "when AES is available in hardware" is a non sequitur.</p>
<p>To be even clearer, we still use AES in key pieces of the protocol (oops, no pun intended), and we sure do take advantage of the hardware acceleration.</p>
<p>You're right to wonder about whether ECC is indeed as robust as RSA -- a lot of people have been researching exactly that question lately. But 1024-bit RSA is very clearly bad news by now (the key is just too small), and 4096-bit RSA is way way way slower than we can handle in some places (I'm thinking circuit handshakes in particular). At the same time some very smart people (including Dan and Tanja, yes, but not just them) tell us that factoring is likely to have some surprising breakthroughs in the coming years. Those same people tell us that ECC has multiple decades of research in the math world. To me that all adds up to "yay ECC".</p>
<p>(You mention that it makes Tor traffic identifiable as Tor, but that's only the link encryption, which is much less important security-wise than the circuit handshake.)</p>
<p>As for your last concern, if you want to be in a position to assess the security of various mathematical assumptions, you need to go read the papers, not watch speeches.</p>
<p>Hope that helps!</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-227657"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-227657" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">December 22, 2016</p>
    </div>
              <p class="parent visually-hidden">In reply to arma</p>
    <a href="#comment-227657">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-227657" class="permalink" rel="bookmark">I&#039;m not confused, I&#039;ve only</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I'm not confused, I've only focused on the elliptic curves cryptography in general, enforced now in tor for substituting both RSA &amp; AES. I'm sorry if I wasn't clear enough.<br />
Your answer doesn't really convince me about the right choice you made, as the technical head of tor, and please don't use logical fallacies for your arguments.<br />
(For a deep packet inspection algorithm it will be an overkill to differentiate between legit AES based https (especially now that https is pretty much enabled by default and by large based on AES - even the tor website uses it) and AES powered tor, that was and still is my point).</p>
<p>I guess it's more of an actor scale concern, specifically who are you putting yourself against and what factoring capacity that actor really has. The best available factoring algorithm ATM looks to be Shor's and I'm only concerned that by implementing an efficient factoring algo in a video card pool / amazon cloud or in an ASIC based board, soon some smaller actors would be able to mess around with your otherwise beautiful toy. As for the big ones, your toy doesn't really help too much, regardless of what encryption you pick.</p>
<p><a href="https://en.wikipedia.org/wiki/RSA_(cryptosystem)" rel="nofollow">https://en.wikipedia.org/wiki/RSA_(cryptosystem)</a><br />
"in 2011.[30] A theoretical hardware device named TWIRL and described by Shamir and Tromer in 2003 called into question the security of 1024 bit keys. It is currently recommended that n be at least 2048 bits long.[31]<br />
In 1994, Peter Shor showed that a quantum computer (if one could ever be practically created for the purpose) would be able to factor in polynomial time, breaking RSA; see Shor's algorithm."</p>
<p><a href="https://en.wikipedia.org/wiki/Elliptic_curve_cryptography" rel="nofollow">https://en.wikipedia.org/wiki/Elliptic_curve_cryptography</a><br />
"In contrast with its current standing over RSA, elliptic curve cryptography is expected to be more vulnerable to an attack based on Shor's algorithm.["</p>
<p>Unfortunately, as I'm not that much of a math genius I'm trying to look after straight, condensate and objective explanations to my questions and I couldn't' find any with respect to the ECC security. I've mentioned Mr. Bernstein because he is the author of the specific ECC flavor that you have adopted and there is nothing in his speeches and papers that explains why he belies his curves are secure. As for me, I'm more happy with a carefully generated random value out of an infinite pool (very high entropy) and "obfuscated" in a robust algorithm instead of a value out of a finite field, obfuscated through a lame equation.</p>
<p>Hope you take my comment in a positive way, that's apart from your arrogance,  as I do really care about your little toy and I'm using it mainly to protect my privacy in the world wild web. Careful with the logical fallacies and never mind me, just publish the studies and papers you've mentioned, the ones I couldn't find, in a section on the tor website as an argument for your cryptography choices.</p>
<p>I hope too that it helped! See you later alligator!</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div><a id="comment-228701"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-228701" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">December 25, 2016</p>
    </div>
    <a href="#comment-228701">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-228701" class="permalink" rel="bookmark">1) How long will the</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>1) How long will the Archives link (<a href="https://blog.torproject.org/archive" rel="nofollow">https://blog.torproject.org/archive</a>) on this blog remain in the menu while not being useful in any way? </p>
<p>2) Why can't these ANN-type blog posts (or the web site's Downloads section) provide a link to download locations and how-to-build docs? It's been 2 years now that I read these "new version" posts, spend 5-10 minutes trying to figure out where to get the code and then give up. There are probably 000's of others with similar experience.</p>
<p>Please fix these annoyances - it makes the site and content look sloppy. </p>
<p>Thanks for another great update, by the way. v0.3 features look awesome!</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-229024"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-229024" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  arma
  </article>
    <div class="comment-header">
      <p class="comment__submitted">arma said:</p>
      <p class="date-time">December 27, 2016</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-228701" class="permalink" rel="bookmark">1) How long will the</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-229024">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-229024" class="permalink" rel="bookmark">1) Until we move to the new</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>1) Until we move to the new blog. Any month now I hear! Try not to disturb too much of the duct tape still left on this one, because we need it to hobble along for a little while more.</p>
<p>2) Hm. Well, most people should not need to build it themselves. Most people should be using Tor Browser, and getting this new version of Tor when Tor Browser gets it. The power users can get it from their operating system packages. Also, in the past when we gave people URLs for how to find the tarball, they got super confused because they were totally unprepared to use a tarball.</p>
<p>That said, I agree with you that it used to be not obvious *when* you're going to have this Tor in your Tor Browser. That's why I asked Nick to add a sentence about that, which he did.<br />
<a href="https://trac.torproject.org/projects/tor/ticket/20725" rel="nofollow">https://trac.torproject.org/projects/tor/ticket/20725</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
</div>
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
